// Copyright 2021 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by protoc-gen-go_gapic. DO NOT EDIT.

package shell_test

import (
	"context"

	shell "cloud.google.com/go/shell/apiv1"
	shellpb "google.golang.org/genproto/googleapis/cloud/shell/v1"
)

func ExampleNewCloudShellClient() {
	ctx := context.Background()
	c, err := shell.NewCloudShellClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	// TODO: Use client.
	_ = c
}

func ExampleCloudShellClient_GetEnvironment() {
	ctx := context.Background()
	c, err := shell.NewCloudShellClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &shellpb.GetEnvironmentRequest{
		// TODO: Fill request struct fields.
	}
	resp, err := c.GetEnvironment(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleCloudShellClient_StartEnvironment() {
	ctx := context.Background()
	c, err := shell.NewCloudShellClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &shellpb.StartEnvironmentRequest{
		// TODO: Fill request struct fields.
	}
	op, err := c.StartEnvironment(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}

	resp, err := op.Wait(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleCloudShellClient_AuthorizeEnvironment() {
	ctx := context.Background()
	c, err := shell.NewCloudShellClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &shellpb.AuthorizeEnvironmentRequest{
		// TODO: Fill request struct fields.
	}
	op, err := c.AuthorizeEnvironment(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}

	resp, err := op.Wait(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleCloudShellClient_AddPublicKey() {
	ctx := context.Background()
	c, err := shell.NewCloudShellClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &shellpb.AddPublicKeyRequest{
		// TODO: Fill request struct fields.
	}
	op, err := c.AddPublicKey(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}

	resp, err := op.Wait(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleCloudShellClient_RemovePublicKey() {
	ctx := context.Background()
	c, err := shell.NewCloudShellClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &shellpb.RemovePublicKeyRequest{
		// TODO: Fill request struct fields.
	}
	op, err := c.RemovePublicKey(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}

	resp, err := op.Wait(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}
